<script setup lang="ts">
    import { computed, onMounted } from "vue";
    import { VTextField } from "vuetify/components";

    const passwordStorageKey = "stored_password";

    const props = defineProps(["modelValue"]);
    const emit = defineEmits(["update:modelValue"]);

    let storageEnabled = false;

    let password = computed({
        get: () => props.modelValue,
        set: (value: any): void => {
            emit("update:modelValue", value);
        },
    });

    function store(event: any) {
        const data = event.srcElement._value;

        if (storageEnabled) {
            localStorage.setItem(passwordStorageKey, data);
        }
    }

    onMounted(() => {
        const stored_password = localStorage.getItem(passwordStorageKey); // very secure I know. Peak development
        if (stored_password != undefined && stored_password != null) {
            password.value = stored_password;
        }

        storageEnabled = true;
    });
</script>

<template>
    <v-text-field
        class="v-col-10 v-col-md-3"
        type="password"
        v-model="password"
        @blur="store"
        density="compact"
        label="Passwort:"
    />
</template>

<style scoped></style>
